<template>
  <div>
    <default-spinner-component :loading-message="loadingMessage"
      v-if="loadingData"
      style="width:50%;"/>
    <div v-if="itemDataReturned"
      style="margin-top:-10px;">
      <ul style="list-style-type:none;">
        <li v-for="item in itemStockData"
          :key="item.shopName">
          <v-card class="defaultCardBackground"
            style="width:100%;margin:10px auto;height:auto;min-height:200px;position:relative;display:block;padding-bottom:30px;">
            <v-layout row
              justify-space-between
              style="padding:15px 0px;"
              v-bind="gridResponsiveness">
              <v-flex xs5
                style="border-right:1px solid #819ca9;">
                <div style="font-size: 30px;text-align: center;height:auto;min-height: 70px;padding-top: 10px;color: #2b8ba3;">
                  {{item.shopName}}
                </div>
              </v-flex>
              <v-flex xs7>
                <div style="padding-top:5px;">
                  <span style="display:block;float:left;padding-top:17px;margin-left:20%;">
                    Number of items
                  </span>
                  <span style="font-size: 40px;font-weight: lighter;color: #ff9100;font-size: 40px;font-weight: lighter;color: #ff9100;">
                    {{item.numberOfItems}}
                  </span>
                </div>
              </v-flex>
            </v-layout>
            <ul style="list-style-type:none;">
              <li v-for="brandElement in item.bransAndSize"
                :key="brandElement.brand">
                <div style="background: #e0e9ef;padding: 15px 2px 15px 20px;position:relative">
                  <span class="detailLabel">
                    Brand
                  </span>
                  &nbsp;&nbsp; {{brandElement.brand}}
                  <v-btn fab
                    depressed
                    dark
                    small
                    color="secondary"
                    slot="activator"
                    @click="moveItemClicked(brandElement,item.shopName)"
                    style="width: 40px !important;height: 40px;padding-top: 0px;margin-top:-8px;position:relative;float:right;top: 0px;right: 2% !important;" >
                    <v-icon dark
                      id="userIconPreferences"
                      style="color:#FFFFFF">
                      local_car_wash
                    </v-icon>
                  </v-btn>
                </div>
                <ul style="list-style-type:none;">
                  <li v-for="sizeElement in brandElement.sizes"
                    :key="sizeElement.size"
                    style="padding: 7px 2px 7px 40px;">
                    <span class="detailLabel">
                      Size
                    </span>
                    {{sizeElement.size}} &nbsp; &nbsp;
                    <span class="detailLabel">
                      Number
                    </span>
                    &nbsp;&nbsp;{{sizeElement.number}}
                  </li>
                </ul>
              </li>
            </ul>
          </v-card>
        </li>
      </ul>
    </div>
  </div>
</template>
<script>
import axios from 'axios'
import DefaultSpinnerComponent from './../common/spinner.vue'
export default {
  name: 'ItemStock',
  components: {
    DefaultSpinnerComponent
  },
  data: () => ({
    loadingData: false,
    itemDataReturned: false,
    loadingMessage: 'Loading item ...',
    itemData: []
  }),
  methods: {
    moveItemClicked (selectedBrand, shopName) {
      let moveItemFullInfo = selectedBrand
      moveItemFullInfo.shopName = shopName
      this.$store.commit('ON_MOVE_ITEMS_CLICK', moveItemFullInfo)
    },
    populateData () {
      this.loadingData = true
      this.itemDataReturned = false
      axios.get('/item/' + this.$route.params.id)
        .then(response => {
          setTimeout(() => {
            this.loadingData = false
            this.itemDataReturned = true
            this.itemData = response.data
          }, 2000)
        })
        .catch(error => {
          this.loadingData = false
          this.itemDataReturned = false
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in viewing item: ' + error)
        })
    }
  },
  computed: {
    itemStockData () {
      let rawItemData = this.itemData.itemInfo
      let itemStockData = []
      rawItemData.forEach(element => {
        element.numberOfItems = 0
        element.bransAndSize.forEach(brandAndSizeEelement => {
          brandAndSizeEelement.sizes.forEach(sizeElement => {
            element.numberOfItems = element.numberOfItems + sizeElement.number
          })
        })
        itemStockData.push(element)
      })
      return itemStockData
    },
    gridResponsiveness () {
      const gridResponsiveness = {}
      if (this.$vuetify.breakpoint.width <= 550) gridResponsiveness.column = true
      return gridResponsiveness
    }
  },
  watch: {
    '$route' (to, from) {
      this.populateData()
    }
  },
  created () {
    this.populateData()
  }
}
</script>
<style scoped>
  .storeNameText {
    font-size: 30px !important;
    text-align: center;
    background: #e0e0e0;
    height: 70px;
    padding-top: 10px;
    color: #2b8ba3;
  }
  #userIconPreferences{
    color: #4d4d4d;
    font-size: 30px;
    padding-top: 3px;
}
#userIconPreferencesCircleContainer{
  position: absolute;
  right: 10px;
}
</style>
